/*int xKoordinate = 0;      //Variablen für die Orientierung auf der Tischplatte
int yKoordinate = 0;
float winkel = 0;*/

#include <Stepper.h>
#include <Servo.h>
 const int stepsPerRevolution = 800;  // change this to fit the number of steps per revolution
 Stepper myStepper1(stepsPerRevolution, A2, A3); //links
 Stepper myStepper2(stepsPerRevolution, A0, A1); //rechts
 Servo motor1;
 Servo motor2;

// Farbsensor Pins
#define S2 7
#define S3 8
#define sensorOUT 9

// Konstante für die Sensorkalibrierung:
int R_WHITE = 16;
int R_BLACK = 175;
int G_WHITE = 17;
int G_BLACK = 225;
int B_WHITE = 14;
int B_BLACK = 175;
int C_WHITE = 6;
int C_BLACK = 67;
int farbsensor_messwerte [4];


void setup() {
  Serial.begin(9600);
  //pinMode(S2, OUTPUT);
  //pinMode(S3, OUTPUT);
  pinMode(2, OUTPUT); // Trigger-Pin ist ein Ausgang
  pinMode(3, INPUT); // Echo-Pin ist ein Eingang
  pinMode(10, OUTPUT); // Trigger-Pin ist ein Ausgang
  pinMode(11, INPUT); // Echo-Pin ist ein Eingang
  pinMode(12, INPUT); // Echo-Pin ist ein Eingang
  motor1.attach(5);
  motor2.attach(6);
  myStepper1.setSpeed(100);
  myStepper2.setSpeed(100);
}

void loop() {
  motor1.write(0);
  motor2.write(180);
  int entfernung = messe_abstand(2,3);
  int entfernung_boden_links = messe_abstand(10,12);
  int entfernung_boden_rechts = messe_abstand(10,11);
  if (entfernung > 2){
    while ((entfernung_boden_rechts <= 5) && (entfernung_boden_links <= 5)){
      myStepper1.step(1);
      myStepper2.step(1);
      //xKoordinate = cos(winkel)*15;
      //yKoordinate = sin(winkel)*15;
    }
    if ((entfernung_boden_links > 5) && (entfernung_boden_rechts <= 5)){
      myStepper1.step(100);
      myStepper2.step(-100);
      //winkel += 6;
    }
    if ((entfernung_boden_rechts > 5) && (entfernung_boden_links <= 5)){
      myStepper1.step(-100);
      myStepper2.step(100);
      //winkel -= 6;
    }
    if ((entfernung_boden_rechts > 5) && (entfernung_boden_links > 5)){
      myStepper1.step(-635);
      myStepper2.step(635);
      myStepper1.step(-635);
      myStepper2.step(635);
      //winkel -= 120;
    }
  }
  if (entfernung<=2){
    aufnehmen();
    /*while (winkel < 360){     //Drehen des Roboters in die Ausgangsposition, sofern er richtig mitgezählt hat
        winkel += 360;}
    while (winkel > 360){
        winkel -= 360;}
    while (winkel > 0){
      myStepper1.step(-10);
      myStepper2.step(10);
      winkel -= 1;
    }*/
    while(1){};
  }
}

int messe_abstand(int trigger, int echo){ //gibt Abstand des Sensors zu nächstem Objekt in ausgerichteter Richtung zurück
  digitalWrite(trigger, LOW); 
  delay(5);
  digitalWrite(trigger, HIGH);
  delay(10);
  digitalWrite(trigger, LOW);
  long dauer = pulseIn(echo, HIGH);
  long entfernung = (dauer/2) * 0.03432;
  //Serial.println("Entf: " + String(entfernung));
  return(entfernung);
}

void aufnehmen(){
   motor1.write(80);
   motor2.write(80);
   farbsensor_messung();
    /*for (int i = 0; i<=3; i++){       //Ausgabe der Farbsensormesswerte zum prüfen der Genauigkeit
    Serial.println(String(i) + ":" +String(farbsensor_messwerte[i])+ " ");
    }*/
    if (farbsensor_messwerte[0]>-100 and farbsensor_messwerte[0]<100 and farbsensor_messwerte[1]>-50 and farbsensor_messwerte[1]<150 and farbsensor_messwerte[2]>-50 and farbsensor_messwerte[2]<170 and farbsensor_messwerte[3]>-50 and farbsensor_messwerte[3]<150){
      Serial.println("Schwarz");
      for (int frequenz = 1000; frequenz>200; frequenz--){
        tone(A5, frequenz);
        delay(5);}
      noTone(A5);}
    if (farbsensor_messwerte[0]>220 and farbsensor_messwerte[0]<260 and farbsensor_messwerte[1]>220 and farbsensor_messwerte[1]<260 and farbsensor_messwerte[2]>220 and farbsensor_messwerte[2]<260 and farbsensor_messwerte[3]>220 and farbsensor_messwerte[3]<260){
      Serial.println("Rosa");
      for (int i = 0; i<800; i++){
        tone(A5, 500);
        delay(5);}
      noTone(A5);}
    if (farbsensor_messwerte[0]>100 and farbsensor_messwerte[0]<220 and farbsensor_messwerte[1]>140 and farbsensor_messwerte[1]<220 and farbsensor_messwerte[2]>170 and farbsensor_messwerte[2]<220 and farbsensor_messwerte[3]>150 and farbsensor_messwerte[3]<210){
      Serial.println("Blau");
      for (int i = 0; i<800; i++){
        tone(A5, 700);
        delay(5);}
      noTone(A5);}
}

int farbsensor_messung(){
  farbsensor_messwerte[0] = (map(farbsensor_mittelwert(0), R_BLACK, R_WHITE, 0, 255)+map(farbsensor_mittelwert(0), R_BLACK, R_WHITE, 0, 255)+map(farbsensor_mittelwert(0), R_BLACK, R_WHITE, 0, 255)+map(farbsensor_mittelwert(0), R_BLACK, R_WHITE, 0, 255)+map(farbsensor_mittelwert(0), R_BLACK, R_WHITE, 0, 255))/5;
  farbsensor_messwerte[1] = (map(farbsensor_mittelwert(1), G_BLACK, G_WHITE, 0, 255)+map(farbsensor_mittelwert(1), G_BLACK, G_WHITE, 0, 255)+map(farbsensor_mittelwert(1), G_BLACK, G_WHITE, 0, 255)+map(farbsensor_mittelwert(1), G_BLACK, G_WHITE, 0, 255)+map(farbsensor_mittelwert(1), G_BLACK, G_WHITE, 0, 255))/5;
  farbsensor_messwerte[2] = (map(farbsensor_mittelwert(2), B_BLACK, B_WHITE, 0, 255)+map(farbsensor_mittelwert(2), B_BLACK, B_WHITE, 0, 255)+map(farbsensor_mittelwert(2), B_BLACK, B_WHITE, 0, 255)+map(farbsensor_mittelwert(2), B_BLACK, B_WHITE, 0, 255)+map(farbsensor_mittelwert(2), B_BLACK, B_WHITE, 0, 255))/5;
  farbsensor_messwerte[3] = (map(farbsensor_mittelwert(3), C_BLACK, C_WHITE, 0, 255)+map(farbsensor_mittelwert(3), C_BLACK, C_WHITE, 0, 255)+map(farbsensor_mittelwert(3), C_BLACK, C_WHITE, 0, 255)+map(farbsensor_mittelwert(3), C_BLACK, C_WHITE, 0, 255)+map(farbsensor_mittelwert(3), C_BLACK, C_WHITE, 0, 255))/5;
}

float farbsensor_mittelwert(int channel) {
  for (int i = 0; i < 5; i++) {
    float mittelwert;
    if (channel == 0 || channel == 2) {
      digitalWrite(S2, LOW);
    }
    else {
      digitalWrite(S2, HIGH);
    }

    if (channel == 0 || channel == 3) {
      digitalWrite(S3, LOW);
    }
    else {
      digitalWrite(S3, HIGH);
    }

    int valueSensor = pulseIn(sensorOUT, LOW);
    mittelwert += valueSensor;
    return mittelwert;
  }
}
